/*
    Posadis - A DNS Server
    Universal readline include file
    Copyright (C) 2002  Meilof Veeningen <meilof@users.sourceforge.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __POSADIS_UNIREADLINE_H
#define __POSADIS_UNIREADLIEN_H

#include <config.h>

#ifdef HAVE_LIBREADLINE

#   ifdef _WIN32 /* win32-readline doesn't define this itself */
#     define RL_READLINE_VERSION 0x0402
#   endif

#   define __READLINE_IMPORT__ 1
#   include <stdio.h>

#   ifdef HAVE_READLINE_H
#       include <readline.h>
#       define READLINE_INCLUDED
#   endif

#   ifdef HAVE_READLINE_READLINE_H
#       include <readline/readline.h>
#       define READLINE_INCLUDED
#   endif

#   ifdef HAVE_HISTORY_H
#       include <history.h>
#       define HISTORY_INCLUDED
#   endif

#   ifdef HAVE_READLINE_HISTORY_H
#       include <readline/history.h>
#       define HISTORY_INCLUDED
#   endif

#   ifdef HAVE_RL_COMPLETION_MATCHES
inline char ** completion_matches(char *arg, CPFunction *fn) {
    return rl_completion_matches(arg, (rl_compentry_func_t *) fn);
}
#   endif

#   if RL_READLINE_VERSION >= 0x0402
#       define compentry_fn rl_compentry_func_t*
#   else
#       define compentry_fn Function *
#   endif

#endif /* HAVE_LIBREADLINE */


#endif /* __POSADIS_UNIREADLINE_H */
