/*
    Posadis - A DNS Server
    Universal include file for sockets, since different OS'ses use different directories
    Copyright (C) 2001  Meilof Veeningen <meilof@users.sourceforge.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __POSADIS_UNISOCK_H
#define __POSADIS_UNISOCK_H

#include <config.h>

#if defined(_WIN32)
#    define socklen_t int

#  ifdef HAVE_IPV6
#     include <winsock2.h>
#     include <ws2tcpip.h>
#     include "winip6.h"
//#    include <windows.h>

//#    include <winsock2.h>
//#    include <ws2tcpip.h>
//#    include "winip6.h"
/*#    undef _WIN32_WINNT
#    define _WIN32_WINNT 0x550
#    define _WINSOCK2API_
#    define _WS2TCPIP_H_
#    include <tpipv6.h> */

#  else
#    include <winsock.h>

#  endif

#  include <io.h>
#  include <sys/time.h>

#else

#  include <sys/time.h>
#  include <sys/socket.h>
#  include <netinet/in.h>
#  include <arpa/inet.h>
#  include <netdb.h>

#endif /* ifdef _WIN32 */

#ifdef HAVE_IPV6
#define _addr sockaddr_storage
#ifdef HAVE___SS_FAMILY
#define s_family __ss_family /* debian fix */
#else
#define s_family ss_family
#endif
#else
#define _addr sockaddr
#define s_family sa_family
#endif

#endif /* __POSADIS_UNISOCK_H */

