/*
    Posadis - A DNS Server
    Universal include file for millisecond times
    Copyright (C) 2001  Meilof Veeningen <meilof@users.sourceforge.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


/* millisecond time */

#ifndef HAVE_GETTIMEOFDAY

#include <sys/types.h>
#include <sys/timeb.h>

struct our_timeval {
	long tv_sec;
	long tv_usec;
};

#define gettimeofday(a, b) ( \
	{ struct timeb _gettimeofday_tmp; \
    ftime(&_gettimeofday_tmp); \
	(a)->tv_sec = _gettimeofday_tmp.time; \
	(a)->tv_usec = _gettimeofday_tmp.millitm * 1000; } \
)

#else

#include <sys/time.h>

#define our_timeval timeval

#endif
