/*
 * Query - Send query to domain name server
 *
 * Copyright (C) Meilof Veeningen, 2002
 */

#include <config.h>

#include <classes.h>
#include <dnstypes.h>
#include <syssocket.h>

typedef enum { PROTO_TCP = 1, PROTO_UDP = 2 } _transport;

class query_info {
  public:
	query_info();
	~query_info();
	
	int connect(_addr *_server, _transport trans = PROTO_UDP);
	int nsquery(DnsMessage *q, DnsMessage **a, int timeout = 0);
  void *doquery();
  int cancel();
	int disconnect();
	
	int timeout;
	_transport transport;
	_addr server;
    char *errmsg;

  protected:
  int retcode;
	int sockid;
  int disconnected;

  DnsMessage *query, **answer;
  int curtimeout;
};

DnsMessage *make_query(_domain dname, u_short qtype);
