/*
    Posadis - A DNS Server
    The AutoGrowBuffer - A char buffer which automagically grows as you cat information to it
    Copyright (C) 2001  Meilof Veeningen <meilof@users.sourceforge.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __AGB_H
#define __AGB_H

class AgBuffer;

class AgBuffer {
    public:
    AgBuffer(); // constructor
    ~AgBuffer(); // destructor
    char *buff; // the buffer itself
    int bufflen; // the size of the buffer
    int reallen; // the actual size of the allocated data

    void enlarge(int len); // enlarges the buffer by <len> bytes
    void cat(char *tbuff, int tbufflen); // char buffs
	void catstring(char *string); // strings
    void catint(int value); // 32-bit signed data
    void catshort(short value); // 16-bit unsigned data
    void modshort(int pos, int val); // modifies 16-bit unsigned data
    void catchar(char value); // char
#undef setbit // mac os x fix: some osx header file happily defines setbit
    void setbit(int pos, int bit); // sets a bit, enlarging the buffer if nessecary
    void set4bit(int pos, int bitfrom, int size); // writes 4-bit number size on pos from bitfrom
    void cutto(int len); // cuts the buffer to the specified size

    void unreg(); // the caller function now takes over the buffer, and we reinitialize it to NULL

    protected:
    void _enlarge(int len); // enlarges the buffer without incrementing bufflen
};

#endif /* ifndef __AGB_H */

