/*
    Posadis - A DNS Server
    Class which holds a list of bits
    Copyright (C) 2001  Meilof Veeningen <meilof@users.sourceforge.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __BITLIST_H
#define __BITLIST_H

#ifdef isset
#undef isset
#endif

class BitList {
  public:
    BitList(long nValues);                          // constructor
    ~BitList();                                     // destructor
    bool isset(long ix);                            // boolean: is the item set?
    int set(long ix);                               // sets ix to true
    int unset(long ix);                             // sets ix to false
    int toggle(long ix);                            // changes true to false, and false to true in ix
  private:
    char *bytes;                                    // internal data
    long nVals;                                     // number of values
};

#endif /* ifndef __BITLIST_H */
