/*
    Posadis - A DNS Server
    Cache Lookup Functions
    Copyright (C) 2001  Meilof Veeningen <meilof@users.sourceforge.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __CACHELOOKUP_H
#define __CACHELOOKUP_H

#define LOOKUP_NOTFOUND 0
#define LOOKUP_FOUND 1024
#define LOOKUP_CREATED 2048

#include "cache.h"
#include "zones.h"

#define lookup_flag_cname 1

int LookupZone(Zone*& res, _domain dom);
int RelativeLookup(CacheItem*& res, Zone *zone, _domain dom, int flags = 0);
int LookupDomain(CacheItem*& resitem, Zone*& reszone, _domain dom, int flags = 0);

/* extended for internal use */
int RelativeLookupEx(CacheItem*& res, Zone *zone, _domain dom, int reclevel = 0);
int LookupDomainEx(CacheItem*& resitem, Zone*& reszone, _domain dom, int reclevel = 0);

// returns 1 if created, 0 if already existed, <0 if erroneous
int CreateDomain(CacheItem*& res, Zone *zone, _domain dom);

#endif /* ifndef __CACHELOOKUP_H */

