/*
    Posadis - A DNS Server
    Program-wide constants for DNS operation
    Copyright (C) 2001  Meilof Veeningen <meilof@users.sourceforge.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#ifndef __DNSCONSTANTS_H
#define __DNSCONSTANTS_H

#define UDP_MSG_SIZE               512
#define DNS_PORT                    53

/* internet protocol numbers */
#define IPN_TCP                      6
#define IPN_UDP                     17

/* dns entry types and question patterns */
#define DNS_TYPE_A                   1
#define DNS_TYPE_NS                  2
#define DNS_TYPE_MD                  3
#define DNS_TYPE_MF                  4
#define DNS_TYPE_CNAME               5
#define DNS_TYPE_SOA                 6
#define DNS_TYPE_MB                  7
#define DNS_TYPE_MG                  8
#define DNS_TYPE_MR                  9
#define DNS_TYPE_NULL               10
#define DNS_TYPE_WKS                11
#define DNS_TYPE_PTR                12
#define DNS_TYPE_HINFO              13
#define DNS_TYPE_MINFO              14
#define DNS_TYPE_MX                 15
#define DNS_TYPE_TXT                16
#define DNS_TYPE_AAAA               28
#define DNS_TYPE_A6                 38
#define DNS_TYPE_DNAME              39

#define QTYPE_IXFR                 251
#define QTYPE_AXFR                 252
#define QTYPE_MAILB                253
#define QTYPE_MAILA                254
#define QTYPE_ALL                  255

/* dns class types and question patterns */
#define CLASS_IN                     1
#define CLASS_CS                     2
#define CLASS_CH                     3
#define CLASS_HS                     4

#define QCLASS_ALL                 255

/* rcodes */
#define RCODE_NOERROR                0
#define RCODE_QUERYERROR             1
#define RCODE_QUERYERR               1
#define RCODE_FORMERR                1
#define RCODE_SERVERFAILURE          2
#define RCODE_SERVFAIL               2
#define RCODE_NXDOMAIN               3
#define RCODE_NOTIMPLEMENTED         4
#define RCODE_NOTIMP                 4
#define RCODE_REFUSED                5
#define RCODE_NOTAUTH                9

/* opcodes */
#define OPCODE_QUERY                 0
#define OPCODE_IQUERY                1
#define OPCODE_STATUS                2
/* opcode 3 (completion) is not supported */
#define OPCODE_NOTIFY                4
#define OPCODE_UPDATE                5

#endif /* ifndef __DNSCONSTANTS_H */

