/*
    Posadis - A DNS Server
    The RR center - a universal way of handeling RR's
    Copyright (C) 2001  Meilof Veeningen <meilof@users.sourceforge.net>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef __RR_H
#define __RR_H

#include "dnstypes.h"

extern const int SECTION_PROC_NONE, SECTION_PROC_A;

struct rr_type {
    char name[9];      /* the name that appears in dns master files */
    int type;          /* the type index of the rr type */
    char properties[9];/* the properties it contains (null-separated string) */
                       /* codes: [d]omain name, [i]p number, [s]hort (16-bit), [l]ong (32-bit),
                                 [c]haracter string, c[h]aracter strings, [f]oo (nothing particular)
                                 [w]ell-known service list (including protocol), ipv[6] [m]ail */
    int section_proc;  /* the section processing the RR needs */
    bool needs_decompression;/* sets whether the item will need to be interpreted (i.e. compression expansion) from and to dns messages;
                           this must be true if it contains a domain name */
    bool compress_dname;/* sets whether the domain names should be compressed in outgoing dns messages */
};

extern const int N_RR_TYPES;
extern const rr_type rr_types[];

/* rr helper functions */

rr_type *rrtype_getinfo(u_short type);		// returns a structure containing rr type information
rr_type *rrtype_getinfo(char *name);		// returns a structure containing rr type information
bool support_type(u_short qtype);           // checks whether we support the specified rr type

#endif /* ifndef __RR_H */
